﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class KeyType : MonoBehaviour {
	public int score = 0;
	public float level = 0.0f;
	public float waveSpeed = -1.5f;
	private string strWord = "";
	private string strPressed = "";
	public Texture2D tex;
	GameObject curr;
	public GameObject spawner;
	public GameObject obj;

	public AudioClip correct;
	public AudioClip wrong;
	public AudioClip gameOver;
	public AudioClip[] attack;

	private AudioSource source;

	private float waitTime = 0.3f;
	private bool isWave = false;

	public GameObject player;

	public bool isGameOver = false;

	private float gameOverTime = 2.0f;


	private Animator anim;

	void Awake() {
		source = GetComponent<AudioSource> ();
	}

	// Use this for initialization
	void Start () {
		strWord = GenerateString();
		anim = player.GetComponent<Animator> ();
	}
	
	// Update is called once per frame
	void Update () {
		if(Input.anyKeyDown) {
			if (Input.GetMouseButtonDown(0) 
				|| Input.GetMouseButtonDown(1)
				|| Input.GetMouseButtonDown(2))
				return;
			if (Input.GetKeyDown (KeyCode.Q)) {
				strPressed += 'Q';
			} else if (Input.GetKeyDown (KeyCode.W)) {
				strPressed += 'W';
			} else if (Input.GetKeyDown (KeyCode.E)) {
				strPressed += 'E';
			} else if (Input.GetKeyDown (KeyCode.R)) {
				strPressed += 'R';
			} else if (Input.GetKeyDown (KeyCode.T)) {
				strPressed += 'T';
			} else if (Input.GetKeyDown (KeyCode.Y)) {
				strPressed += 'Y';
			} else if (Input.GetKeyDown (KeyCode.U)) {
				strPressed += 'U';
			} else if (Input.GetKeyDown (KeyCode.I)) {
				strPressed += 'I';
			} else if (Input.GetKeyDown (KeyCode.O)) {
				strPressed += 'O';
			} else if (Input.GetKeyDown (KeyCode.P)) {
				strPressed += 'P';
			} else if (Input.GetKeyDown (KeyCode.A)) {
				strPressed += 'A';
			} else if (Input.GetKeyDown (KeyCode.S)) {
				strPressed += 'S';
			} else if (Input.GetKeyDown (KeyCode.D)) {
				strPressed += 'D';
			} else if (Input.GetKeyDown (KeyCode.F)) {
				strPressed += 'F';
			} else if (Input.GetKeyDown (KeyCode.G)) {
				strPressed += 'G';
			} else if (Input.GetKeyDown (KeyCode.H)) {
				strPressed += 'H';
			} else if (Input.GetKeyDown (KeyCode.J)) {
				strPressed += 'J';
			} else if (Input.GetKeyDown (KeyCode.K)) {
				strPressed += 'K';
			} else if (Input.GetKeyDown (KeyCode.L)) {
				strPressed += 'L';
			} else if (Input.GetKeyDown (KeyCode.Z)) {
				strPressed += 'Z';
			} else if (Input.GetKeyDown (KeyCode.X)) {
				strPressed += 'X';
			} else if (Input.GetKeyDown (KeyCode.C)) {
				strPressed += 'C';
			} else if (Input.GetKeyDown (KeyCode.V)) {
				strPressed += 'V';
			} else if (Input.GetKeyDown (KeyCode.B)) {
				strPressed += 'B';
			} else if (Input.GetKeyDown (KeyCode.N)) {
				strPressed += 'N';
			} else if (Input.GetKeyDown (KeyCode.M)) {
				strPressed += 'M';
			} else {
				return;
			}
		Check();
		}
		if (this.isWave) {
			this.waitTime -= Time.deltaTime;
			if (this.waitTime < 0) {
				this.isWave = false;
				this.waitTime = 0.3f;
				Instantiate (obj, spawner.transform.position, spawner.transform.rotation);
				this.anim.SetBool ("isAttack1", false);
			}
		}
		if (this.isGameOver) {
			this.gameOverTime -= Time.deltaTime;
			if (this.gameOverTime < 0) {
				SceneManager.LoadScene ("gameover", LoadSceneMode.Single);
			}
		}
	}
	
	private bool Check() {
		int currIndex = strPressed.Length-1;
		if(strPressed.Length > strWord.Length) {
			strPressed = "";	
			strWord = GenerateString();
		}else if(strPressed.Length == strWord.Length) {
			if(strWord[currIndex] == strPressed[currIndex]) {
				this.anim.SetBool ("isAttack1", true);
				source.PlayOneShot(attack[Random.Range(0, attack.Length)]);
				this.isWave = true;

				score++;
				if (level < 2.5f) {
					level += 0.1f;
				}
				if (waveSpeed > -2.0f) {
					waveSpeed -= 0.1f;
				}
				curr = GameObject.Find("Score");
				curr.GetComponent<Text>().text = score.ToString();
			}else {
			}
			strPressed = "";	
			strWord = GenerateString();
		}else{		
			if(strWord[currIndex] != strPressed[currIndex]) {
				source.PlayOneShot (wrong);
				strPressed = "";			
				strWord = GenerateString();
			}else {
				source.PlayOneShot (correct);
				UpdateLetter(strPressed[currIndex], currIndex, true);
			}
		}
		return false;
	}
	
	private string GenerateString() {
		const string glyphs= "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		string strRandom = "";
		for (int i=0; i < 3; i++) {
			strRandom += glyphs[Random.Range(0, glyphs.Length - 1)];
			UpdateLetter(strRandom[i], i, false);
		}
		return strRandom;
	}

	private void UpdateLetter(char letter, int i, bool flag) {
		string strPath="";
		if(i == 0) {
			curr = GameObject.Find("First Char");
		}else if(i==1) {
			curr = GameObject.Find("Second Char");
		}else if(i==2) {
			curr = GameObject.Find("Third Char");
		}
		if (flag) {
			strPath = "LettersInactive/" + letter + "2";
		} else {
			strPath = "LettersActive/" + letter;
		}
		tex = (Texture2D)Resources.Load(strPath);
		curr.GetComponent<SpriteRenderer>().sprite = Sprite.Create(tex, new Rect(0.0f,0.0f,tex.width,tex.height), new Vector2(0.5f,0.5f), 100.0f);;

	}

	private void ShakeLetter(GameObject letter) {
		float speed = 1.0f;
		Vector3 movement = Vector3.zero;
		movement.x = Mathf.Sin (Time.time * speed);
		letter.transform.Translate (movement);
	}
}
