﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class WaveMove : MonoBehaviour {

	private float maximumTime = 10.0f;
	private GameObject control;

	private Vector3 speed;
	private Vector3 displacement;

	public AudioClip[] die;

	private Animator animator;
	private AudioSource source;

	void Awake(){
		source = GetComponent<AudioSource> ();
	}

	// Use this for initialization
	void Start () {
		control = GameObject.Find ("GameControl");
		speed = new Vector3 (control.GetComponent<KeyType> ().waveSpeed, 0, 0);
		animator = GetComponent<Animator> ();
	}

	// Update is called once per frame
	void Update () {
	}

	void LateUpdate() {
		displacement = speed * Time.deltaTime;
		transform.Translate (displacement);

		maximumTime -= Time.deltaTime;
		if (maximumTime <= 0) {
			Destroy (gameObject);
		}
	}


	void OnTriggerEnter2D(Collider2D other) {
		Debug.Log (other.gameObject.tag);
		if (other.gameObject.tag == "wind") {
			Destroy (other.gameObject);
			this.animator.SetBool ("isDestroyed", true);
			GetComponent<BoxCollider2D> ().enabled = false;
			this.maximumTime = 0.5f;
		}
		if (other.gameObject.tag == "Player") {
			source.PlayOneShot(die[Random.Range(0, die.Length)]);
			GameObject.Find ("GameControl").GetComponent<KeyType> ().isGameOver = true;
		}
	}
}
